DIPlib Documentation - ©1995-2009 Quantitative Imaging Group, Delft University of Technology.

# Rotation3d

Interpolation function

## SYNOPSIS

`#include "dip_interpolation.h"`

dip_Error dip_Rotation3d ( in, out, alpha, beta, gamma, method, bgval )

## DATA TYPES

binary, integer, float

## FUNCTION

This function rotates an 3-D image `in` via the three Euler angles `alpha`, `beta`, `gamma` to `out` using nine skews. The first rotation is about `alpha` around the initial 3-axis. The second about `beta` around the intermediate 2-axis and the last about `gamma` around the final 3-axis. The function implements the rotation in the mathmetical sense, but note the Y-axis is positive downwards! The rotation is over the centre of the image.

## ARGUMENTS

Data type | Name | Description
`dip_Image` | `in` | Input image
`dip_Image` | `out` | Output image
`dip_float` | `alpha (radians)` | Euler angle
`dip_float` | `beta (radians)` | Euler angle
`dip_float` | `gamma (radians)` | Euler angle
`dipf_Interpolation` | `method` | Interpolation method
`dip_BackgroundValue` | `bgval` | Background value

The enumerator `dip_FilterShape` contains the following constants:

Name | Description
`DIP_FLT_SHAPE_DEFAULT` | default structuring element, same as `DIP_FLT_SHAPE_RECTANGULAR`
`DIP_FLT_SHAPE_RECTANGULAR` | rectangular structuring element
`DIP_FLT_SHAPE_ELLIPTIC` | elliptic structuring element
`DIP_FLT_SHAPE_DIAMOND` | diamond shaped structuring element
`DIP_FLT_SHAPE_PARABOLIC` | parabolic structuring element
`DIP_FLT_SHAPE_STRUCTURING_ELEMENT` | use `se` as structuring element

The `dip_BackgroundValue` enumaration consists of the following flags:

Name | Description
`DIP_BGV_DEFAULT` | Default: fill with zeros
`DIP_BGV_ZERO` | Fill with zeros
`DIP_BGV_MAX_VALUE` | Fill with maximum value for data type
`DIP_BGV_MIN_VALUE` | Fill with minimum value for data type

## KNOWN BUGS

This function is only implemented for 3D images.

## SEE ALSO

`Skewing`, `Rotation3dAxis`

DIPlib on-line documentation | Function reference | Global function index